#include <ADUC814.H>
#include <stdio.h>

void main (void)
{
unsigned char chan_2_convert;

/*-----------------------------------------------
Configure the serial port to run at 9600 Baud.
Yeah, this is really slow!
-----------------------------------------------*/
SCON  = 0x50;
TMOD |= 0x20;
TH1   = 0xA0;
TR1   = 1;
TI    = 1;

/*-----------------------------------------------
Configure the A/D to sequentially convert each
input channel.
-----------------------------------------------*/
ADCCON1 = 0x8C;

while (1)
  {
  unsigned int conv_val;

/*-----------------------------------------------
Start a conversion and wait for it to complete.
-----------------------------------------------*/
  chan_2_convert = (chan_2_convert + 1) % 6;
  ADCCON2 = (ADCCON2 & 0xF0) | chan_2_convert;
  SCONV = 1;
  while (ADCCON3 & 0x80);

/*-----------------------------------------------
Read A/D data and print it out.
-----------------------------------------------*/
  conv_val = ADCDATAL | ((ADCDATAH & 0x0F) << 8);

  printf ("ADC Channel %bu = 0x%4.4X\r\n", chan_2_convert, conv_val);
  }

}

